# Developers

- [Architecture Overview](https://www.build3.network/developers/architecture-overview.md): What we're using and ways we're using it.
- [Consensus](https://www.build3.network/developers/architecture-overview/consensus.md): Notes about the chain spec, and launching nodes..
- [Storage](https://www.build3.network/developers/architecture-overview/storage.md): The block size limitations make storing large values a challenge. How do we deal with that?
- [Notes about Substrate](https://www.build3.network/developers/notes-about-substrate.md): Quick-start guide on substrate framework (before you dive in too far)
- [Runtime](https://www.build3.network/developers/notes-about-substrate/runtime.md): Where the heart of the business logic lives.
- [FRAME Pallet](https://www.build3.network/developers/notes-about-substrate/frame-pallet.md): FRAMPallets are individual pieces of runtime logic for us in FRAME runtimes.
- [Imports](https://www.build3.network/developers/notes-about-substrate/frame-pallet/imports.md): The most critical imports for every Pallet
- [Runtime Configuration Trait](https://www.build3.network/developers/notes-about-substrate/frame-pallet/runtime-configuration-trait.md): The configuration trait is a way for you to allow external pallets to define the element types being used on your internal pallet.
- [Runtime Storage](https://www.build3.network/developers/notes-about-substrate/frame-pallet/runtime-storage.md)
- [Runtime Events](https://www.build3.network/developers/notes-about-substrate/frame-pallet/runtime-events.md): How to tell someone using your blockchain something happened.
- [Hook](https://www.build3.network/developers/notes-about-substrate/frame-pallet/hook.md)
- [Extrinsics (Dispatchable Calls)](https://www.build3.network/developers/notes-about-substrate/frame-pallet/extrinsics-dispatchable-calls.md): These are the public endpoints you are giving to users to interact with the blockchain.
- [Other Important Crates](https://www.build3.network/developers/notes-about-substrate/other-important-crates.md)
- [frame\_system](https://www.build3.network/developers/notes-about-substrate/other-important-crates/frame_system.md): The system crate that defines the core types for runtimes.
- [frame\_support](https://www.build3.network/developers/notes-about-substrate/other-important-crates/frame_support.md): documentation pending...
- [frame\_executive](https://www.build3.network/developers/notes-about-substrate/other-important-crates/frame_executive.md): documentation pending...
- [Prebuilt Pallets](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets.md): These are some useful pallets that ship with susbrate\_.
- [Assets](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/assets.md): Dealing with simple fungible assets.
- [Atomic Swap](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/atomic-swap.md): A way for someone to submit a claim to sent something to another party to accept the claim later.
- [Balances](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/balances.md)
- [Benchmark](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/benchmark.md): Contains common runtime patterns in an isolated manner. Not meant for production blockchain, just for benchmarking and testing.
- [Collective](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/collective.md): A set of account IDs to make collective feelings known through dispatched calls from specialized origins.
- [Contracts](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/contracts.md): Allows runtime to deploy and execute WASM smart-contracts.
- [Democracy](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/democracy.md)
- [Elections Phragmén](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/elections-phragmen.md)
- [Off-chain Worker](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/off-chain-worker.md): Off-chain workers.
- [GRANDPA](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/grandpa.md): GRANDPA consensus by managing the GRANDPA authority set ready for the native code.
- [Identity](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/identity.md): Federated naming system, allowing for multiple registrars to be added from a specified origin.
- [Indices](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/indices.md)
- [Membership](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/membership.md): Allows control of membership of a set of AccountId's. Useful for managing membership of a collective.
- [Multisig](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/multisig.md): Doing multi-signature dispatches.
- [Offences](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/offences.md): Tracks offenses against specific origins.
- [Proxy](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/proxy.md): Allows accounts to give permission to other accounts to dispatch types of calls from their signed origin.
- [Recovery](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/recovery.md): Allows users to gain access to their accounts if the private key or other authentication mechanism is lost.
- [Scheduler](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/scheduler.md)
- [Scored Pool](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/scored-pool.md)
- [Society](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/society.md)
- [Staking](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/staking.md): Used to manage funds as stake by network maintainers.
- [Sudo](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/sudo.md)
- [Timestamp](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/timestamp.md): Get and set the on-chain time.
- [Transaction Payment](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/transaction-payment.md): The basic logic to compute pre-dispatch transaction fees.
- [Treasury](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/treasury.md)
- [Utility](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/utility.md): Stateless module with helpers for dispatch management.
- [Vesting](https://www.build3.network/developers/notes-about-substrate/prebuilt-pallets/vesting.md): Provides a means for placing a linear curve on an account's locked balance. T
- [ink! Smart Contracts](https://www.build3.network/developers/notes-about-substrate/ink-smart-contracts.md): The smart contract language and development tools for substrate\_ frameworks.
- [Development](https://www.build3.network/developers/notes-about-substrate/ink-smart-contracts/development.md): An overview of building and configuring smart contracts with build3 foundation blockchain.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://www.build3.network/developers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
